
*********This do-file replicates the results reported in the main text and the Online Appendix****************
*********of the article "Do they know something we don't?Diffusion of repression in authoritarian regimes"****
*******In case of any questions, contact the author at olarr@tcd.ie*******************************************

***Models in the article***

use "diffusion_repression.dta", clear

*Model 1
reg repression SL_repression_cooptation lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

*Model 2
reg repression SL_repression_structural lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*Model 3
reg repression SL_repression_cooptation SL_repression_structural lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*


***Figure 1*** (after manual edit)
use "substantive_effects.dta", clear 

*label define Variables 1 "Wy: Short Term Institutional Similarity" 2 "Wy: Long Term Institutional Similarity" 3 "Wy: Short Experiential Similarity" 4 "Wy: Long Term Experiential Similarity" 5 "Wy: Short Term Institutional Model 3" 6 "Wy: Long Term Institutional Model 3" 7 "Wy: Short Experiential Similarity Model 3" 8 "Wy: Long Term Experiential Model 3" 

*label values var Variables

twoway (scatter var estimate if model==1, sort) (scatter var estimate if model==2, sort) (rcap lb ub var if model==1, horizontal) (rcap lb ub var if model==2, horizontal)  ///
		(scatter var estimate if model==3, sort) (scatter var estimate if model==4, sort) (rcap lb ub var if model==3, horizontal) (rcap lb ub var if model==4, horizontal), ///
		xline(0, lpattern(dash)) legend(on) scheme(s1mono) name(graph2, replace)


                                         *************ROBUSTNESS CHECKS in the Online Appendix*************

** 2) Models with Fariss (2014) latent measure of human rights violations
use "diffusion_repression.dta", clear

*Model A1
reg latentmean SL_fariss_cooptation lag_repression_fariss cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*Model A2
reg latentmean SL_fariss_structural lag_repression_fariss cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*


*Model A3
reg latentmean SL_fariss_cooptation SL_fariss_structural lag_repression_fariss cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*


**3) Neighbouring repression to account for geographic clusterring due to unobserved heterogeneity

*Model A4 (neighbouring repression at t)
reg repression SL_repression_cooptation SL_repression_neigh lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

***Inverse distance
reg repression SL_repression_cooptation SL_lagrepression_inv lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*Model A5
reg repression SL_repression_structural SL_repression_neigh lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

**Inverse distance
reg repression SL_repression_structural SL_lagrepression_inv lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*Model A6
reg repression SL_repression_cooptation SL_repression_structural SL_repression_neigh lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*inverse distance
reg repression SL_repression_cooptation SL_repression_structural SL_lagrepression_inv lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*


**4) Neighbouring events & conflict SL_dissent_navco_cooptation
*Model A7 - Conflict in same institutional peer group
reg repression SL_repression_cooptation SL_conflict_cooptation lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*Model A8
reg repression SL_repression_structural SL_conflict_cooptation lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*Model A9
reg repression SL_repression_cooptation SL_repression_structural SL_conflict_cooptation lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*


**Leader exit in neighbouring countries via coups or nonviolent dissent
*Model A10  
reg repression SL_repression_cooptation SL_coups_neigh SL_navcos_neigh lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*Model A11 - coup attempts in the neighbouring countries
reg repression SL_repression_cooptation SL_coupa_neigh lag_repression cooptation avg_gdp avg_pop dissent cold_war SL_conflict_neigh y_fe* ccode_fe*

 **International alliances and pressures
**5) *Model A12 - Neighbouring democracy from V-Dem
reg repression SL_repression_cooptation SL_polyarchy_neigh lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*Model A13 - Model 2 + neighbouring democracy
reg repression SL_repression_structural SL_polyarchy_neigh lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*Model A15 - Model 3 + neighbouring democracy
reg repression SL_repression_cooptation SL_repression_structural SL_polyarchy_neigh lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

**6) US and Russian allies and foreign aid
*Model A16 - Model 1 + foreign aid and US/Soviet allies
reg repression SL_repression_cooptation russia_ally us_ally wdi_l1234aidpc lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*Model A17 - Model 2 + foreign aid and US/Soviet allies
reg repression SL_repression_structural russia_ally us_ally wdi_l1234aidpc lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*

*Model A18 - Model 3 + foreign aid and US/Soviet allies
reg repression SL_repression_cooptation SL_repression_structural russia_ally us_ally wdi_l1234aidpc lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*


***Model A19 - CIRI
use "main_ciri.dta", clear
reg rep_ciri  SL_repression_cooptation_ciri lag_ciri cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

reg rep_ciri SL_repression_structural_ciri lag_ciri cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

reg rep_ciri SL_repression_cooptation_ciri lag_ciri SL_repression_structural_ciri cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*


***Table A11 - Model Comparison***
 
 *Model 1
use "main_compare.dta"
reg repression SL_repression_cooptation lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

*Model A1 with Fariss
reg latentmean SL_fariss_cooptation lag_repression_fariss cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe* if e(sample)

***Model A19 - CIRI
reg rep_ciri  SL_repression_cooptation_ciri lag_ciri cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe* if e(sample)

*Model A21 - PTS State DV
reg PTS_S SL_ptss_cooptation lag_ptss cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe* if e(sample)

*Model A22 - Geddes Controls only
use "main_types.dta"
reg repression SL_repression_cooptation lag_repression i.types cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

***End of model comparison

*Model A23 - Geddes typologies Spatial Lag
 use "main_types.dta", clear
reg repression SL_repression_types lag_repression i.types avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

*Model A24 - Geddes SL & Cooptation SL
 use "main_types.dta"
reg repression SL_repression_cooptation SL_repression_types lag_repression i.types cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*


***Non-violent repression***
 use "diffusion_repression.dta"
reg repression SL_repression_cooptation lag_repression SL_nvrepression_coop v2x_clpol cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*


*Model A25 - Structure of security forces
*Simple
 use "diffusion_repression.dta"
reg repression SL_repression_cooptation lag_repression i.nominal cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

*Spatial Lag
 use "diffusion_repression.dta"
reg repression SL_repression_cooptation SL_repression_security lag_repression i.nominal cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

**Model A20 - Allies Spatial Lag
 use "diffusion_repression.dta"
reg repression SL_repression_cooptation SL_repression_allies formal_allies lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

*Model A27 - UN GA voting ideal point estimation Spatial Lag
 use "diffusion_repression.dta"
reg repression SL_repression_cooptation SL_UN_ideal lag_repression Idealpoint cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

*Model A27 - Random effects
xtreg repression SL_repression_cooptation lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war, re

*Baseline Model
reg repression SL_repression_cooptation lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

*Baseline model minus time fixed effect
reg repression SL_repression_cooptation lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war ccode_fe*

*Model A26 - GDP Growth, Life Expectancy and Youth Bulge
reg repression SL_repression_cooptation lag_repression e_migdpgro cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

reg repression SL_repression_cooptation lag_repression e_pelifeex youth_bulge cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*

reg repression SL_repression_cooptation lag_repression youth_bulge cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war  y_fe* ccode_fe*


 ************Spatial Maximum Likelihood Model ***********


**Model 1 (institutional peers) with lagged DV

use "diffusion_repression.dta", clear
clear
pr drop _all
set matsize 8000
set more off
version 9                                                    

program define splag_ll

args lnf mu rho sigma
tempvar A rSL
gen `A'= ones - `rho'*EIGS1
gen `rSL'=`rho'*SL1
qui replace `lnf'= ln(`A') + ln(normden($ML_y1-`rSL'-`mu', 0, `sigma'))
end

global nobs = 4171

clear
spatwmat using "W_coop", name(W)standardize
matrix eigenvalues eig1 imaginaryv = W
matrix eig2 = eig1'
matrix ones=J($nobs,1,1)

drop _all

use "diffusion_repression.dta", clear

global Y repression
global X lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*
global Z lag_repression
mkmat $Y, matrix(Y)
mkmat $Z, matrix(Z)
matrix SL = W*Z
svmat SL, n(SL)
svmat eig2, n(EIGS)
svmat ones, n(ones)

qui regress $Y $X
matrix OLSb=e(b)
local OLSsigma=e(rmse)

ml model lf splag_ll (mu: $Y=$X) (rho:) (sigma:), technique(dfp) vce(oim)
ml init OLSb, skip
ml init rho:_cons=0
ml init sigma:_cons=`OLSsigma'
**play around with the tolerance first and only then try changing the initialization of rho
ml max, difficult ltolerance(1e-8) tolerance(1e-8)


**Model 2 (experiential peers) with lagged DV
 
use "diffusion_repression.dta", clear
clear
pr drop _all
set matsize 8000
set more off
version 9                                                    

program define splag_ll

args lnf mu rho sigma
tempvar A rSL
gen `A'= ones - `rho'*EIGS1
gen `rSL'=`rho'*SL1
qui replace `lnf'= ln(`A') + ln(normden($ML_y1-`rSL'-`mu', 0, `sigma'))
end

global nobs = 4171

clear
spatwmat using "W_structural", name(W)standardize
matrix eigenvalues eig1 imaginaryv = W
matrix eig2 = eig1'
matrix ones=J($nobs,1,1)

drop _all

use "diffusion_repression.dta", clear

global Y repression
global X lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*
global Z lag_repression
mkmat $Y, matrix(Y)
mkmat $Z, matrix(Z)
matrix SL = W*Z
svmat SL, n(SL)
svmat eig2, n(EIGS)
svmat ones, n(ones)

qui regress $Y $X
matrix OLSb=e(b)
local OLSsigma=e(rmse)

ml model lf splag_ll (mu: $Y=$X) (rho:) (sigma:), technique(dfp) vce(oim)
ml init OLSb, skip
ml init rho:_cons=0
ml init sigma:_cons=`OLSsigma'
**play around with the tolerance first and only then try changing the initialization of rho
ml max, difficult ltolerance(1e-8) tolerance(1e-8)

**Model 3 (m-Star model)
set more off
use "diffusion_repression.dta", clear

clear
pr drop _all
set more off
set matsize 8000
                                                     
program define splag_ll

args lnf mu rho1 rho2 sigma
tempvar A rSL1 rSL2 
gen double `rSL1'=`rho1'*SL1
gen double `rSL2'=`rho2'*SL2
scalar p1 = `rho1'
scalar p2 = `rho2'
matrix p1W1 = p1*W1
matrix p2W2 = p2*W2
matrix IpW = I_n - p1W1 - p2W2
qui gen double `A' = ln(det(IpW))/$nobs if _n == 1
scalar A = `A'
qui replace `lnf'= A + ln(normalden($ML_y1-`rSL1'-`rSL2'-`mu', 0, `sigma'))
end

spatwmat using "W_coop.dta", name(W1)standardize

spatwmat using "W_structural.dta", name(W2)standardize

drop _all
use "diffusion_repression.dta", clear
global nobs = 4171
matrix I_n = I($nobs)
global Y repression
global X lag_repression cooptation avg_gdp avg_pop dissent SL_conflict_neigh cold_war y_fe* ccode_fe*
global Z lag_repression
mkmat $Y, matrix(Y)
mkmat $Z, matrix(Z)
matrix SL1 = W1*Z
svmat SL1, n(SL1)
matrix SL2 = W2*Z
svmat SL2, n(SL2)

qui regress $Y $X
matrix OLSb=e(b)
local OLSsigma=e(rmse)

ml model lf splag_ll (mu: $Y=$X) (rho1:) (rho2:) (sigma:)
ml init OLSb, skip
ml init rho1:_cons=0
ml init rho2:_cons=0
ml init sigma:_cons=`OLSsigma'
ml max




